/* R-U-ON Agents plugin          */
/* Copyright (c) 2006 R-U-ON LLC */
/* www.r-u-on.com                */

plugin.onShowOptionsDlg = showOptions;
plugin.onAddCustomMenuItems = AddCustomMenuItems;

function parseGuid(text) {
    try {   
        var doc = new DOMDocument();
        doc.loadXML(text);
        
        var err = doc.getElementsByTagName("error")[0];
        if (err!=null) {
            alert(err.firstChild.nodeValue+"\r\n\r\nPlease try again.");
            return;
        }
        var guid = doc.getElementsByTagName("guid")[0];
        if (guid!=null) {
            options("guid")=guid.firstChild.nodeValue;
            onTimer();
            return;
        }
        alert("Unexpected data from the server\r\n\r\nPlease try again.");
    } catch(e) {
        alert(e.message+"\r\n\r\nPlease try again.")
    }
}

function showOptions(window) {

    window.AddControl(gddWndCtrlClassLabel, 0, "", "Enter your R-U-ON account details",    10, 10, 190, 20);
    window.AddControl(gddWndCtrlClassLabel, 0, "", "Email: ",    10, 37, 150, 20);
    var eb = window.AddControl(gddWndCtrlClassEdit, 0, "emailBox", "",    80, 35, 150, 23);
    window.AddControl(gddWndCtrlClassLabel, 0, "", "Password: ", 10, 67, 150, 20); 
    window.AddControl(gddWndCtrlClassEdit, gddWndCtrlTypeEditPassword, "passwordBox", "", 80, 65, 150, 20); 
    eb.value = options("email");
    window.onClose = OnOptionsClose;

    function OnOptionsClose(window, code) {
        if (code == gddIdOK) {
            var ok = false;
            var email = window.GetControl("emailBox").value;
            var password = window.GetControl("passwordBox").value;
            options("email") = email;


            var url = "https://www.r-u-on.com/resolveGUID?";
            url += 'email='+escape(email)+"&password="+escape(password);

            var req = new XMLHttpRequest();
            req.onreadystatechange = accountId;
            req.open("GET", url, true);
            req.send();
            function accountId() {
                if (req.readyState == 4) {
                    if (req.status == 200) {
                        parseGuid(req.responseText);
                    } else {
                        alert("Service not available. Please try again.");
                    }
                }
            }
        }        
    }
}


function AddCustomMenuItems(menu) {

    menu.AddItem("Refresh", 0, MenuItemClicked);
}

function MenuItemClicked(item) {
    onTimer();
}
